/* 
 *   Gnome Klotski: Klotski clone
 *   Written by Lars Rydlinge <lars.rydlinge@hig.se>
 * 
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <config.h>
#include <gnome.h>
#include <libgnomeui/gnome-window-icon.h>
#include "pieces.h"

#define APPNAME "gnotski"
#define APPNAME_LONG "Gnome Klotski"

#define TILE_SIZE 34

#define RELEASE 4
#define PRESS 3
#define MOVING 2
#define UNUSED 1
#define USED 0

GtkWidget *window;
GtkWidget *statusbar;
GtkWidget *space;
GtkWidget *move_value;

GdkPixmap *buffer = NULL;
GdkPixmap *tiles_pixmap = NULL;

GdkColor bg_color;

char *map = NULL;
char *tmpmap = NULL;
char *move_map = NULL;
char *orig_map = NULL;

gint statusbar_id,height=-1,width=-1,moves=0;

int session_flag = 0;
int session_xpos = 0;
int session_ypos = 0;
int session_position  = 0;

char current_level[16];

void create_window();
void create_space();
void create_statusbar();

void redraw_all();
void message(gchar *);
void load_image();
void gui_draw_pixmap(char *, gint, gint);
int get_piece_nr(char *,int,int);
int get_piece_id(char *,int,int);
void set_piece_id(char *,int,int,int);
int check_valid_move(int, int, int);
int do_move_piece(int, int, int);
int move_piece(int,int,int,int,int);
void copymap(char *,char *);
int mapcmp(char *,char *);
static int save_state(GnomeClient *,gint, GnomeRestartStyle, gint,
                      GnomeInteractStyle, gint fast, gpointer);
void print_map(char *);
void set_move(int);
void new_move();
int game_over();
void game_score();

/* ------------------------- MENU ------------------------ */
void new_game_cb(GtkWidget *, gpointer);
void quit_game_cb(GtkWidget *, gpointer);
void level_cb(GtkWidget *, gpointer);
void about_cb(GtkWidget *, gpointer);
void score_cb(GtkWidget *, gpointer);

